SystemOrganization addCategory: #'SUML-Tools'!

!ObjectDiagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 02:49'!
diagramListModelClass 
	^ObjectDiagramModel ! !

SHWorkspace subclass: #DiagramWorkspace
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 03:37'!
acceptContents: aText from: anEditor
	self model clearRelationshipsOfSelectedDiagramNode.
	anEditor selectAll;  doIt.
	self model acceptContents: aText .
	self acceptContents: aText.! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 23:52'!
bindingOf: aString
	^self model bindingOf: aString! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:25'!
descriptionCode
	^self model selectedDescriptionCode ! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 02:49'!
doItReceiver 
	^model model! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 17:12'!
hasBindingOf: aString
	^self model hasBindingOf: aString! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 17:10'!
model
	^ model! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 10/19/2010 22:12'!
model: anObject
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
	model initializeBindings.! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 9/13/2010 10:50'!
update: aParameter
	(aParameter = #descriptionCode)
		ifTrue:[self acceptContents: model selectedDescriptionCode].
	self changed: aParameter! !

!Diagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 02:28'!
diagramListModelClass 
	self subclassResponsibility ! !

!Diagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 03:44'!
modelForDiagramsHolder: aDiagramsHolder
	^(self diagramListModelClass new model: self  ) ! !

SystemWindow subclass: #UMLDiagramWindow
	instanceVariableNames: 'diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!UMLDiagramWindow class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:42'!
on: aModel
	^(self new model: aModel) createView ! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 19:53'!
acceptContents: contents 
	self model: (Compiler evaluate: contents)! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 20:17'!
createView 
	| diagramCode scrollPane|
	diagramCode  := (PluggableShoutEditorMorph 
		on: (DiagramWorkspace new model: model diagramListModel) 
		text: #descriptionCode 
		accept: #acceptContents:from:
		readSelection: nil 
		menu: #codePaneMenu:shifted:).
scrollPane := ScrollPane new.
diagram := DiagramWhiteboard new . 
diagram extent: 1000@2000.
diagram clipSubmorphs: false.
diagram model: model.
diagram update.
scrollPane scroller addMorph: diagram.

self addMorph: scrollPane frame: (0@0 corner: 1@0.8).
self addMorph: (self diagramsList addDependent: diagram; yourself)frame: (0@0.8 corner: 0.25@1).
self addMorph: self descriptionsList frame: (0.25@0.8 corner: 0.5@1).
self addMorph: diagramCode frame: (0.5@0.8 corner: 1@1).
! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 19:57'!
descriptionCode 
	^model ifNil: [''] ifNotNil: [model descriptionCode] ! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 02:00'!
descriptionsList
	^PluggableListMorph new
		on: self model diagramListModel
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: #listMenu:shifted:
		keystroke: #listKey:from:;
		 borderWidth: 0;
		 enableDragNDrop: false;
		 autoDeselect: true;
		 yourself! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 23:44'!
diagramsList
	^PluggableListMorph new
		on: self model
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: #listMenu:shifted:
		keystroke: #listKey:from:;
		 borderWidth: 0;
		 enableDragNDrop: false;
		 autoDeselect: true;
		 yourself! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:46'!
model: aModel
	super model: aModel.
	self setLabel: model diagramName.

! !

!UMLDiagramWindow methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:00'!
selectedDescriptionModel
	^self model diagramListModel ! !

PluggableShoutMorph subclass: #PluggableShoutEditorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!PluggableShoutEditorMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:03'!
selectAll
	super selectAll.
	selectionInterval := self textMorph editor selectionInterval.! !

!PluggableShoutEditorMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:01'!
selectFrom: start to: stop
	super selectFrom: start to: stop.
	selectionInterval := self textMorph editor selectionInterval.! !

!ClassDiagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 02:28'!
diagramListModelClass 
	^ClassDiagramModel! !

Object subclass: #NullDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:08'!
classBoxes
	^#()! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:12'!
descriptionCodeOf: aClassDescription
	^String empty! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:30'!
diagramNodes
	^#()! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 11:24'!
modelForDiagramsHolder: aDiagramsHolder
	^(DiagramModel new model: self  ) ! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 17:23'!
name
	^'(No diagrams)'! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 11:29'!
saveDescriptionIn: aClass 
	! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 17:18'!
update! !

Object subclass: #NullDiagramNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!NullDiagramNode methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:48'!
descriptionCodeForEdition
	^String empty ! !

Object subclass: #UMLDiagramListModel
	instanceVariableNames: 'diagramModel selectedIndex bindings diagramsHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 10/30/2010 16:30'!
acceptContents: aText 
	"The binding actually has an Updater"
	self bindingOfSelectedDiagramNode update.
	self changed: #list.
	self changed: #descriptionCode.
	self changed: #view.
	self changed.! !

!UMLDiagramListModel methodsFor: 'binding' stamp: 'carlaGriggio 11/11/2010 21:02'!
bindingOf: aString
	^self model bindingOf: aString ! !

!UMLDiagramListModel methodsFor: 'binding' stamp: 'carlaGriggio 8/20/2010 03:38'!
bindingOfSelectedDiagramNode
	^(self bindingOf: self selectedDiagramNode variableNameForDescriptionCode) value! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 00:07'!
category
	^self model category! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 21:06'!
changed
	self initializeBindings.
	self changed: #list.
	self changed: #view.
	self changed: #descriptionCode.
	super changed.! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 11:55'!
changed: aParameter
	((aParameter = #position) or:[(aParameter = #descriptionCode)]) 
		ifTrue: [self selectedDiagram saveDescriptionIn: self diagramsHolder.]. 
	((aParameter ~= #descriptionCode) and:[(aParameter  ~= #list)]) 
		ifTrue:[self model changed: aParameter].
	((aParameter = #selectedIndex) or:[aParameter = #position])
		ifTrue:[
			self changed: #descriptionCode.].
	(aParameter = #view)
		ifTrue:[
			self diagramsHolder changed: #view].
		super changed: aParameter ! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 03:38'!
clearRelationshipsOfSelectedDiagramNode 
	self bindingOfSelectedDiagramNode clearRelationships ! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 00:07'!
diagramName 
	^self selectedDiagram name! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 04:43'!
diagramNodes
	^self selectedDiagram  diagramNodes ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 03:39'!
diagramsHolder
	^ diagramsHolder! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 04:06'!
diagramsHolder: anObject
	diagramsHolder := anObject! !

!UMLDiagramListModel methodsFor: 'binding' stamp: 'carlaGriggio 11/11/2010 21:03'!
hasBindingOf: aString
	^self model hasBindingOf: aString ! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 00:07'!
initialize 
	selectedIndex := 1.! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2010 21:05'!
initializeBindings 
	self model initializeBindings ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:23'!
list
	^self model list! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 05:31'!
listMenu: aMenu shifted: shifted
	aMenu target: self model.
	^self model listMenu: aMenu shifted: shifted! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:21'!
model
	^ diagramModel ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2010 21:05'!
model: anObject
	diagramModel  := anObject.
	diagramModel ifNotNil: [diagramModel removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	self initializeBindings.
	selectedIndex := 1.
	self changed: #list
	! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:28'!
selectedDescriptionCode
	^self selectedDiagram descriptionCodeOf: self selectedDiagramNode! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:28'!
selectedDiagram
	^self model model! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2010 09:59'!
selectedDiagramNode
	^self model selectedDiagramNode ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 00:07'!
selectedIndex
	^ selectedIndex! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:53'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			self changed: #selectedIndex.
			]! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 11:49'!
update: aParameter
	(aParameter = #list) ifTrue:[self changed: #list].
	(aParameter = #descriptionCode)
		ifTrue:[self changed: #descriptionCode].

	(aParameter = #view)
		ifTrue:[self diagramsHolder changed: #view].
			
	(aParameter = #selectedIndex )
		ifTrue:[
				
				self model selectedIndex: self selectedIndex. 
				
				self changed: #list. 
				self changed: #descriptionCode].
	super update: aParameter.
	self initializeBindings.! !

!UMLDiagramListModel methodsFor: 'updating' stamp: 'carlaGriggio 9/13/2010 10:40'!
updateView
	self dependents do:[:dep | dep update: #view]! !

Object subclass: #UMLToolModel
	instanceVariableNames: 'model selectedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

UMLToolModel subclass: #CategoryDiagramsModel
	instanceVariableNames: 'selectedDiagramModel diagrams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 02:00'!
changed
	self diagramListModel model: self selectedDiagram.
	super changed.! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 10/30/2010 16:37'!
changed: aParameter
	(aParameter = #list) ifTrue:[diagrams:= self model diagrams].
	(aParameter == #selectedIndex)
		ifTrue:[
			self diagramListModel model: self selectedDiagramModel.
"			self diagramListModel changed: #list."
			self diagramListModel changed: #descriptionCode.
			self changed: #view.
			self changed: #relabel].
	super changed: aParameter ! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 11:34'!
createDiagram
	|diagramName|
	diagramName := self request: 'Diagram Name' default: ''.
	self model addDiagram: (ClassDiagram new name: diagramName).
	self changed: #list.
	self selectedIndex: self list size.
	
	! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/30/2010 04:45'!
createInheritanceDiagram
	|className|
	className := self request: 'Root Class for the inheritance diagram' default: ''.
	self model addDiagram: (ClassDiagram inheritanceFor: (Smalltalk at: className asSymbol) ).
	self selectedIndex: self list size.
	self changed: #list.
	! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/30/2010 16:37'!
deleteDiagram
	self model removeDiagram: self selectedDiagram .
	
	self changed: #list.
	(self list notEmpty and:[ self selectedIndex > 1]) 
		ifTrue: [self selectedIndex: self selectedIndex -1].
	(self list notEmpty and:[ self selectedIndex = 1]) 
		ifTrue:[self selectedIndex: 1].
	self changed: #selectedIndex.
	

! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 04:06'!
diagramListModel
	^selectedDiagramModel ifNil:[selectedDiagramModel := UMLDiagramListModel new diagramsHolder: self model; model: (self selectedDiagramModel)]! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/19/2010 20:29'!
diagramNodes
	^self selectedDiagram diagramNodes ! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/10/2010 02:20'!
exportDiagramAsWorkspace
	Workspace new saveString: self selectedDiagram descriptionCode toFile: self selectedDiagram name, '.ws' ! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 16:52'!
labelString
	^self model category, ' - ', self selectedDiagram name! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/19/2010 21:10'!
list
	^diagrams ifNil:[ diagrams:= self model diagrams]! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/30/2010 04:43'!
listMenu: aMenu shifted: aBoolean
	self list ifNotEmpty: [
		aMenu addList: #(
		('delete diagram'	deleteDiagram)
		('rename diagram'	renameDiagram)
		)].
	aMenu addLine.
	aMenu addList: #(('add diagram'	createDiagram)).
	aMenu addList: #(('add inheritance diagram' createInheritanceDiagram)).
	aMenu addLine.
	aMenu addList: #(
		('save diagram as PNG' saveDiagramAsPNG)
		('export diagram description code as a workspace'  exportDiagramAsWorkspace)).
	^ aMenu! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/11/2010 03:49'!
renameDiagram
	|diagramName currentDiagram|
	diagramName := self request: 'New name for ', self selectedDiagram name default: nil.
	diagramName ifNotNil: [currentDiagram := self selectedDiagram.
	self deleteDiagram.
	currentDiagram name: diagramName.
	self model addDiagram: currentDiagram.
	self changed: #list.
	self changed: #selectedIndex.
	self changed.]
	! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2010 01:11'!
saveDiagramAsPNG
	PNGReadWriter putForm: (DiagramWhiteboard new model: self diagramListModel) imageForm onFileNamed: self selectedDiagram name, '.png'.
! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 02:07'!
selectedDiagram
	^ self list at: self selectedIndex ifAbsent:[NullDiagram new]! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 11:33'!
selectedDiagramModel
	^self selectedDiagram modelForDiagramsHolder: self model! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 02:32'!
update: aParameter
	
	(aParameter = #view) ifTrue:[self changed: #view].
	self diagramListModel changed: #descriptionCode.
	super update: aParameter.! !

UMLToolModel subclass: #DiagramModel
	instanceVariableNames: 'bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

DiagramModel subclass: #ClassDiagramModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!ClassDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:01'!
bindingErrorBecauseOf: aVariable
	^'No class description associated with the variable: ', aVariable ! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 13:36'!
chooseClassFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a class from the category ', self category;
		labels: (SystemOrganization classesInCategory: self category);
		lines: #();
		model: (SystemOrganization classesInCategory: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^"self checkBoxName: "choice ]
		ifNil: [ ^dialog filterValue ]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:08'!
chooseTraitFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a trait from the category ', self category;
		labels: (SystemOrganization orderedTraitsIn: self category);
		lines: #();
		model: (SystemOrganization orderedTraitsIn: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^self checkBoxName: choice ]
		ifNil: [ ^dialog filterValue ]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/12/2010 11:55'!
createClassBox
	| className |
	className := self request: 'Class Name' default: ''.
	self checkBoxName: className.
	self model addNewClassDescriptionNamed: className.
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:08'!
createClassBoxFromCategory
	self createClassBoxFromClass: self chooseClassFromCategory.
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:08'!
createClassBoxFromClass
	|className|
	className := self request: 'For which class would you like to create a new Class Box?' default: nil.
	self checkBoxName: className.
	className ifNotNil:[self createClassBoxFromClass: (Smalltalk at: className asSymbol ).
	self changed.]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/11/2010 21:08'!
createClassBoxFromClass: aClass
	aClass ifNotNil: [ self model addDiagramNode: (ClassBox fromClass: aClass )].
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 02:29'!
createInterfaceBox
	| interfaceName |
	interfaceName := self request: 'Interface / Type Name' default: ''.
	self checkBoxName: interfaceName .
	self model addDiagramNode: (InterfaceBox new boxTitle: interfaceName).
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 02:29'!
createTraitBox
	| traitName |
	traitName := self request: 'Trait Name' default: ''.
	self checkBoxName: traitName .
	self model addDiagramNode: (TraitBox new boxTitle: traitName).
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:09'!
createTraitBoxFromCategory
	self createTraitBoxFromTrait: self chooseTraitFromCategory.
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:09'!
createTraitBoxFromTrait
	|traitName|
	traitName := self request: 'For which trait would you like to create a new Trait Box?' default: nil.
	self checkBoxName: traitName .
	self createTraitBoxFromTrait: (Smalltalk at: traitName asSymbol ).
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 02:29'!
createTraitBoxFromTrait: aTrait
	aTrait ifNotNil:[ self model addDiagramNode: (TraitBox  fromTrait: aTrait )]! !

!ClassDiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:10'!
descriptionCode
	^self model descriptionCodeOf: self selectedDiagramNode ! !

!ClassDiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 11:42'!
list
	^self model ifNotNil:[self model diagramNodes]
	ifNil:[#()]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 05:27'!
listMenu: aMenu shifted: shifted
	self list ifNotEmpty:[
		aMenu addList: #(('Delete box'	#deleteNode) ('Rename box'	#renameNode));
			addLine].
		aMenu 
			addList: #(
					('Add new class box' 		#createClassBox) 
					('Add new class box from existing class in category' #createClassBoxFromCategory)
					('Add new class box from existing class' #createClassBoxFromClass)
					('Add new interface / type box' 		#createInterfaceBox)
					('Add new trait box' 		#createTraitBox)
					('Add new trait box from existing trait in category' #createTraitBoxFromCategory)
					('Add new trait box from existing trait' #createTraitBoxFromTrait)
					 ).

	^ aMenu ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:01'!
bindingErrorBecauseOf: aVariable
	self subclassResponsibility ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 21:23'!
bindingOf: aString
	^bindings associationAt: aString ifAbsent:[self error: (self model bindingErrorBecauseOf: aString ) ].! !

!DiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/11/2010 21:20'!
checkBoxName: aBoxName
	(bindings values anySatisfy: [:box | box name = aBoxName ]) ifTrue:[self error: 'There already exists a diagram node named ', aBoxName ].
	^aBoxName ! !

!DiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/11/2010 20:25'!
deleteNode
	self model removeDiagramNode: self selectedDiagramNode .
	self selectedIndex: self selectedIndex -1.
	self changed: #selectedIndex.
	self changed: #view.
	self changed: #descriptionCode.
! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 23:54'!
hasBindingOf: aString
	^(bindings notNil and: [bindings includesKey: aString])! !

!DiagramModel methodsFor: 'binding' stamp: 'carlaGriggio 11/11/2010 21:01'!
initializeBindings
	bindings := Dictionary new.
	self list do:[:de |
		bindings at: de variableNameForDescriptionCode put:  (de updaterClass new realDiagramNode: de)]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/19/2010 22:15'!
list
	^self model ifNotNil:[self model diagramNodes]
	 "This should be changed when integrating other kinds of diagrams, doing a double dispatch maybe"
	ifNil:[#()]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:12'!
model: aModel
	super model: aModel.
! !

!DiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 05:27'!
renameNode
	| newBoxName newVariableName binding |
	newBoxName := self request: ('New name for ', self selectedDiagramNode name) default: ''.
	binding := self bindingOf: self selectedDiagramNode variableNameForDescriptionCode.
	self selectedDiagramNode name: newBoxName.
	binding key: self selectedDiagramNode variableNameForDescriptionCode. 
	self changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:25'!
selectedDescriptionCode
	^self model descriptionCodeOf: self selectedDiagramNode! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 9/13/2010 10:17'!
selectedDiagramNode
	^self list at: self selectedIndex ifAbsent:[NullDiagramNode new]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 9/2/2010 10:50'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			]! !

DiagramModel subclass: #ObjectDiagramModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!ObjectDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:01'!
bindingErrorBecauseOf: aVariable
	^'No object node associated with the variable: ', aVariable ! !

!ObjectDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 05:33'!
createNode
	| name |
	name := self request: 'Object Name' default: ''.
	"self checkBoxName: name."
	self model addDiagramNode: (ObjectNode named: name).
	self changed.! !

!ObjectDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 05:31'!
listMenu: aMenu shifted: shifted
	self list ifNotEmpty:[
		aMenu addList: #(('Delete object'	#deleteNode) ('Rename object'	renameNode));
			addLine].
		aMenu 
			addList: #(
					('Add new object node' 		#createNode) 
					 ).

	^ aMenu ! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:41'!
category
	^self model category! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 00:46'!
diagramName 
	^self selectedDiagram name! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 01:34'!
initialize 
	selectedIndex := 1.! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
list
	self subclassResponsibility! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
model
	^ model! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 10/19/2010 23:01'!
model: anObject
	model := anObject.
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 03:11'!
request: aTitle default: aDefaultValue
	^UIManager default
		request: aTitle
		initialAnswer: aDefaultValue! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
selectedIndex
	^ selectedIndex! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 9/2/2010 10:50'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			self changed: #selectedIndex.
			]! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2010 02:42'!
update: anObject 
	super update: anObject.
	(anObject ~= #descriptionCode) ifTrue: [self changed: #list.]! !
